]> git.sesse.net Git - ffmpeg/blob - tests/fate-run.sh
Merge commit 'a70eac7a9b193e8434b5bed90bd72aa4cb688363'
[ffmpeg] / tests / fate-run.sh
1 #! /bin/sh
2
3 export LC_ALL=C
4
5 base=$(dirname $0)
6 . "${base}/md5.sh"
7
8 base64=tests/base64
9
10 test="${1#fate-}"
11 target_samples=$2
12 target_exec=$3
13 target_path=$4
14 command=$5
15 cmp=${6:-diff}
16 ref=${7:-"${base}/ref/fate/${test}"}
17 fuzz=${8:-1}
18 threads=${9:-1}
19 thread_type=${10:-frame+slice}
20 cpuflags=${11:-all}
21 cmp_shift=${12:-0}
22 cmp_target=${13:-0}
23 size_tolerance=${14:-0}
24 cmp_unit=${15:-2}
25 gen=${16:-no}
26 hwaccel=${17:-none}
27 report_type=${18:-standard}
28 keep=${19:-0}
29
30 outdir="tests/data/fate"
31 outfile="${outdir}/${test}"
32 errfile="${outdir}/${test}.err"
33 cmpfile="${outdir}/${test}.diff"
34 repfile="${outdir}/${test}.rep"
35
36 target_path(){
37     test ${1} = ${1#/} && p=${target_path}/
38     echo ${p}${1}
39 }
40
41 # $1=value1, $2=value2, $3=threshold
42 # prints 0 if absolute difference between value1 and value2 is <= threshold
43 compare(){
44     awk "BEGIN { v = $1 - $2; printf ((v < 0 ? -v : v) > $3) }"
45 }
46
47 do_tiny_psnr(){
48     psnr=$(tests/tiny_psnr "$1" "$2" $cmp_unit $cmp_shift 0) || return 1
49     val=$(expr "$psnr" : ".*$3: *\([0-9.]*\)")
50     size1=$(expr "$psnr" : '.*bytes: *\([0-9]*\)')
51     size2=$(expr "$psnr" : '.*bytes:[ 0-9]*/ *\([0-9]*\)')
52     val_cmp=$(compare $val $cmp_target $fuzz)
53     size_cmp=$(compare $size1 $size2 $size_tolerance)
54     if [ "$val_cmp" != 0 ] || [ "$size_cmp" != 0 ]; then
55         echo "$psnr"
56         if [ "$val_cmp" != 0 ]; then
57             echo "$3: |$val - $cmp_target| >= $fuzz"
58         fi
59         if [ "$size_cmp" != 0 ]; then
60             echo "size: |$size1 - $size2| >= $size_tolerance"
61         fi
62         return 1
63     fi
64 }
65
66 oneoff(){
67     do_tiny_psnr "$1" "$2" MAXDIFF
68 }
69
70 stddev(){
71     do_tiny_psnr "$1" "$2" stddev
72 }
73
74 oneline(){
75     printf '%s\n' "$1" | diff -u -b - "$2"
76 }
77
78 run(){
79     test "${V:-0}" -gt 0 && echo "$target_exec" $target_path/"$@" >&3
80     $target_exec $target_path/"$@"
81 }
82
83 runecho(){
84     test "${V:-0}" -gt 0 && echo "$target_exec" $target_path/"$@" >&3
85     $target_exec $target_path/"$@" >&3
86 }
87
88 probefmt(){
89     run ffprobe${PROGSUF} -show_entries format=format_name -print_format default=nw=1:nk=1 -v 0 "$@"
90 }
91
92 probetags(){
93     run ffprobe${PROGSUF} -show_entries format_tags -v 0 "$@"
94 }
95
96 runlocal(){
97     test "${V:-0}" -gt 0 && echo ${base}/"$@" ${base} >&3
98     ${base}/"$@" ${base}
99 }
100
101 probeframes(){
102     run ffprobe${PROGSUF} -show_frames -v 0 "$@"
103 }
104
105 probechapters(){
106     run ffprobe${PROGSUF} -show_chapters -v 0 "$@"
107 }
108
109 probegaplessinfo(){
110     filename="$1"
111     shift
112     run ffprobe${PROGSUF} -bitexact -select_streams a -show_entries format=start_time,duration:stream=index,start_pts,duration_ts -v 0 "$filename" "$@"
113     pktfile1="${outdir}/${test}.pkts"
114     framefile1="${outdir}/${test}.frames"
115     cleanfiles="$cleanfiles $pktfile1 $framefile1"
116     run ffprobe${PROGSUF} -bitexact -select_streams a -of compact -count_packets -show_entries packet=pts,dts,duration,flags:stream=nb_read_packets -v 0 "$filename" "$@" > "$pktfile1"
117     head -n 8 "$pktfile1"
118     tail -n 9 "$pktfile1"
119     run ffprobe${PROGSUF} -bitexact -select_streams a -of compact -count_frames -show_entries frame=pkt_pts,pkt_dts,best_effort_timestamp,pkt_duration,nb_samples:stream=nb_read_frames -v 0 "$filename" "$@" > "$framefile1"
120     head -n 8 "$framefile1"
121     tail -n 9 "$framefile1"
122 }
123
124 ffmpeg(){
125     dec_opts="-hwaccel $hwaccel -threads $threads -thread_type $thread_type"
126     ffmpeg_args="-nostdin -nostats -cpuflags $cpuflags"
127     for arg in $@; do
128         [ x${arg} = x-i ] && ffmpeg_args="${ffmpeg_args} ${dec_opts}"
129         ffmpeg_args="${ffmpeg_args} ${arg}"
130     done
131     run ffmpeg${PROGSUF} ${ffmpeg_args}
132 }
133
134 framecrc(){
135     ffmpeg "$@" -bitexact -f framecrc -
136 }
137
138 ffmetadata(){
139     ffmpeg "$@" -bitexact -f ffmetadata -
140 }
141
142 framemd5(){
143     ffmpeg "$@" -bitexact -f framemd5 -
144 }
145
146 crc(){
147     ffmpeg "$@" -f crc -
148 }
149
150 md5pipe(){
151     ffmpeg "$@" md5:
152 }
153
154 md5(){
155     encfile="${outdir}/${test}.out"
156     cleanfiles="$cleanfiles $encfile"
157     ffmpeg "$@" $encfile
158     do_md5sum $encfile | awk '{print $1}'
159 }
160
161 pcm(){
162     ffmpeg "$@" -vn -f s16le -
163 }
164
165 fmtstdout(){
166     fmt=$1
167     shift 1
168     ffmpeg -bitexact "$@" -f $fmt -
169 }
170
171 enc_dec_pcm(){
172     out_fmt=$1
173     dec_fmt=$2
174     pcm_fmt=$3
175     src_file=$(target_path $4)
176     shift 4
177     encfile="${outdir}/${test}.${out_fmt}"
178     cleanfiles=$encfile
179     encfile=$(target_path ${encfile})
180     ffmpeg -i $src_file "$@" -f $out_fmt -y ${encfile} || return
181     ffmpeg -bitexact -i ${encfile} -c:a pcm_${pcm_fmt} -fflags +bitexact -f ${dec_fmt} -
182 }
183
184 FLAGS="-flags +bitexact -sws_flags +accurate_rnd+bitexact -fflags +bitexact"
185 DEC_OPTS="-threads $threads -idct simple $FLAGS"
186 ENC_OPTS="-threads 1        -idct simple -dct fastint"
187
188 enc_dec(){
189     src_fmt=$1
190     srcfile=$2
191     enc_fmt=$3
192     enc_opt=$4
193     dec_fmt=$5
194     dec_opt=$6
195     encfile="${outdir}/${test}.${enc_fmt}"
196     decfile="${outdir}/${test}.out.${dec_fmt}"
197     cleanfiles="$cleanfiles $decfile"
198     test "$7" = -keep || cleanfiles="$cleanfiles $encfile"
199     tsrcfile=$(target_path $srcfile)
200     tencfile=$(target_path $encfile)
201     tdecfile=$(target_path $decfile)
202     ffmpeg -f $src_fmt $DEC_OPTS -i $tsrcfile $ENC_OPTS $enc_opt $FLAGS \
203         -f $enc_fmt -y $tencfile || return
204     do_md5sum $encfile
205     echo $(wc -c $encfile)
206     ffmpeg $8 $DEC_OPTS -i $tencfile $ENC_OPTS $dec_opt $FLAGS \
207         -f $dec_fmt -y $tdecfile || return
208     do_md5sum $decfile
209     tests/tiny_psnr $srcfile $decfile $cmp_unit $cmp_shift
210 }
211
212 transcode(){
213     src_fmt=$1
214     srcfile=$2
215     enc_fmt=$3
216     enc_opt=$4
217     final_decode=$5
218     encfile="${outdir}/${test}.${enc_fmt}"
219     test "$7" = -keep || cleanfiles="$cleanfiles $encfile"
220     tsrcfile=$(target_path $srcfile)
221     tencfile=$(target_path $encfile)
222     ffmpeg -f $src_fmt $DEC_OPTS -i $tsrcfile $ENC_OPTS $enc_opt $FLAGS \
223         -f $enc_fmt -y $tencfile || return
224     do_md5sum $encfile
225     echo $(wc -c $encfile)
226     ffmpeg $DEC_OPTS -i $encfile $ENC_OPTS $FLAGS $final_decode \
227         -f framecrc - || return
228 }
229
230 stream_remux(){
231     src_fmt=$1
232     srcfile=$2
233     enc_fmt=$3
234     stream_maps=$4
235     final_decode=$5
236     encfile="${outdir}/${test}.${enc_fmt}"
237     test "$7" = -keep || cleanfiles="$cleanfiles $encfile"
238     tsrcfile=$(target_path $srcfile)
239     tencfile=$(target_path $encfile)
240     ffmpeg -f $src_fmt -i $tsrcfile $stream_maps -codec copy $FLAGS \
241         -f $enc_fmt -y $tencfile || return
242     ffmpeg $DEC_OPTS -i $encfile $ENC_OPTS $FLAGS $final_decode \
243         -f framecrc - || return
244 }
245
246 # FIXME: There is a certain duplication between the avconv-related helper
247 # functions above and below that should be refactored.
248 ffmpeg2="$target_exec ${target_path}/ffmpeg"
249 raw_src="${target_path}/tests/vsynth1/%02d.pgm"
250 crcfile="tests/data/$test.lavf.crc"
251 target_crcfile="${target_path}/$crcfile"
252
253 [ "${V-0}" -gt 0 ] && echov=echov || echov=:
254
255 echov(){
256     echo "$@" >&3
257 }
258
259 AVCONV_OPTS="-nostdin -nostats -y -cpuflags $cpuflags -threads $threads"
260 DEC_OPTS="-flags +bitexact -idct simple -sws_flags +accurate_rnd+bitexact -fflags +bitexact"
261 ENC_OPTS="$DEC_OPTS -threads $threads -dct fastint"
262
263 run_avconv(){
264     $echov $ffmpeg2 $AVCONV_OPTS $*
265     $ffmpeg2 $AVCONV_OPTS $*
266 }
267
268 do_avconv(){
269     f="$1"
270     shift
271     set -- $* ${target_path}/$f
272     run_avconv $*
273     do_md5sum $f
274     echo $(wc -c $f)
275 }
276
277 do_avconv_crc(){
278     f="$1"
279     shift
280     run_avconv $* -f crc "$target_crcfile"
281     echo "$f $(cat $crcfile)"
282 }
283
284 lavf_image2pipe(){
285     t="${test#lavf-}"
286     t="${t%pipe}"
287     outdir="tests/data/lavf"
288     file=${outdir}/${t}pipe.$t
289     do_avconv $file $DEC_OPTS -f image2 -c:v pgmyuv -i $raw_src -f image2pipe "$ENC_OPTS -metadata title=lavftest" -t 1 -qscale 10
290     do_avconv_crc $file $DEC_OPTS -f image2pipe -i $target_path/$file
291 }
292
293 lavffatetest(){
294     t="${test#lavf-fate-}"
295     ref=${base}/ref/lavf-fate/$t
296     ${base}/lavf-regression.sh $t lavf-fate tests/vsynth1 "$target_exec" "$target_path" "$threads" "$thread_type" "$cpuflags" "$target_samples"
297 }
298
299 lavftest(){
300     t="${test#lavf-}"
301     ref=${base}/ref/lavf/$t
302     ${base}/lavf-regression.sh $t lavf tests/vsynth1 "$target_exec" "$target_path" "$threads" "$thread_type" "$cpuflags" "$target_samples"
303 }
304
305 refcmp_metadata(){
306     refcmp=$1
307     pixfmt=$2
308     fuzz=${3:-0.001}
309     ffmpeg $FLAGS $ENC_OPTS \
310         -lavfi "testsrc2=size=300x200:rate=1:duration=5,format=${pixfmt},split[ref][tmp];[tmp]avgblur=4[enc];[enc][ref]${refcmp},metadata=print:file=-" \
311         -f null /dev/null | awk -v ref=${ref} -v fuzz=${fuzz} -f ${base}/refcmp-metadata.awk -
312 }
313
314 video_filter(){
315     filters=$1
316     shift
317     label=${test#filter-}
318     raw_src="${target_path}/tests/vsynth1/%02d.pgm"
319     printf '%-20s' $label
320     ffmpeg $DEC_OPTS -f image2 -vcodec pgmyuv -i $raw_src \
321         $FLAGS $ENC_OPTS -vf "$filters" -vcodec rawvideo -frames:v 5 $* -f nut md5:
322 }
323
324 pixfmts(){
325     filter=${test#filter-pixfmts-}
326     filter=${filter%_*}
327     filter_args=$1
328     prefilter_chain=$2
329     nframes=${3:-1}
330
331     showfiltfmts="$target_exec $target_path/libavfilter/tests/filtfmts"
332     scale_exclude_fmts=${outfile}_scale_exclude_fmts
333     scale_in_fmts=${outfile}_scale_in_fmts
334     scale_out_fmts=${outfile}_scale_out_fmts
335     in_fmts=${outfile}_in_fmts
336
337     # exclude pixel formats which are not supported as input
338     $showfiltfmts scale | awk -F '[ \r]' '/^INPUT/{ fmt=substr($3, 5); print fmt }' | sort >$scale_in_fmts
339     $showfiltfmts scale | awk -F '[ \r]' '/^OUTPUT/{ fmt=substr($3, 5); print fmt }' | sort >$scale_out_fmts
340     comm -12 $scale_in_fmts $scale_out_fmts >$scale_exclude_fmts
341
342     $showfiltfmts $filter | awk -F '[ \r]' '/^INPUT/{ fmt=substr($3, 5); print fmt }' | sort >$in_fmts
343     pix_fmts=$(comm -12 $scale_exclude_fmts $in_fmts)
344
345     outertest=$test
346     for pix_fmt in $pix_fmts; do
347         test=$pix_fmt
348         video_filter "${prefilter_chain}format=$pix_fmt,$filter=$filter_args" -pix_fmt $pix_fmt -frames:v $nframes
349     done
350
351     rm $in_fmts $scale_in_fmts $scale_out_fmts $scale_exclude_fmts
352     test=$outertest
353 }
354
355 gapless(){
356     sample=$(target_path $1)
357     extra_args=$2
358
359     decfile1="${outdir}/${test}.out-1"
360     decfile2="${outdir}/${test}.out-2"
361     decfile3="${outdir}/${test}.out-3"
362     cleanfiles="$cleanfiles $decfile1 $decfile2 $decfile3"
363
364     # test packet data
365     ffmpeg $extra_args -i "$sample" -bitexact -c:a copy -f framecrc -y $decfile1
366     do_md5sum $decfile1
367     # test decoded (and cut) data
368     ffmpeg $extra_args -i "$sample" -bitexact -f wav md5:
369     # the same as above again, with seeking to the start
370     ffmpeg $extra_args -ss 0 -seek_timestamp 1 -i "$sample" -bitexact -c:a copy -f framecrc -y $decfile2
371     do_md5sum $decfile2
372     ffmpeg $extra_args -ss 0 -seek_timestamp 1 -i "$sample" -bitexact -f wav md5:
373     # test packet data, with seeking to a specific position
374     ffmpeg $extra_args -ss 5 -seek_timestamp 1 -i "$sample" -bitexact -c:a copy -f framecrc -y $decfile3
375     do_md5sum $decfile3
376 }
377
378 gaplessenc(){
379     sample=$(target_path $1)
380     format=$2
381     codec=$3
382
383     file1="${outdir}/${test}.out-1"
384     cleanfiles="$cleanfiles $file1"
385
386     # test data after reencoding
387     ffmpeg -i "$sample" -bitexact -map 0:a -c:a $codec -f $format -y "$file1"
388     probegaplessinfo "$file1"
389 }
390
391 audio_match(){
392     sample=$(target_path $1)
393     trefile=$(target_path $2)
394     extra_args=$3
395
396     decfile="${outdir}/${test}.wav"
397     cleanfiles="$cleanfiles $decfile"
398
399     ffmpeg -i "$sample" -bitexact $extra_args -y $decfile
400     tests/audiomatch $decfile $trefile
401 }
402
403 concat(){
404     template=$1
405     sample=$2
406     mode=$3
407     extra_args=$4
408
409     concatfile="${outdir}/${test}.ffconcat"
410     packetfile="${outdir}/${test}.ffprobe"
411     cleanfiles="$concatfile $packetfile"
412
413     awk "{gsub(/%SRCFILE%/, \"$sample\"); print}" $template > $concatfile
414
415     if [ "$mode" = "md5" ]; then
416         run ffprobe${PROGSUF} -bitexact -show_streams -show_packets -v 0 -fflags keepside -safe 0 $extra_args $concatfile | tr -d '\r' > $packetfile
417         do_md5sum $packetfile
418     else
419         run ffprobe${PROGSUF} -bitexact -show_streams -show_packets -v 0 -of compact=p=0:nk=1 -fflags keepside -safe 0 $extra_args $concatfile
420     fi
421 }
422
423 null(){
424     :
425 }
426
427 # Disable globbing: command arguments may contain globbing characters and
428 # must be kept verbatim
429 set -f
430
431 exec 3>&2
432 eval $command >"$outfile" 2>$errfile
433 err=$?
434
435 if [ $err -gt 128 ]; then
436     sig=$(kill -l $err 2>/dev/null)
437     test "${sig}" = "${sig%[!A-Za-z]*}" || unset sig
438 fi
439
440 if test -e "$ref" || test $cmp = "oneline" || test $cmp = "null" || test $cmp = "grep" ; then
441     case $cmp in
442         diff)   diff -u -b "$ref" "$outfile"            >$cmpfile ;;
443         rawdiff)diff -u    "$ref" "$outfile"            >$cmpfile ;;
444         oneoff) oneoff     "$ref" "$outfile"            >$cmpfile ;;
445         stddev) stddev     "$ref" "$outfile"            >$cmpfile ;;
446         oneline)oneline    "$ref" "$outfile"            >$cmpfile ;;
447         grep)   grep       "$ref" "$errfile"            >$cmpfile ;;
448         null)   cat               "$outfile"            >$cmpfile ;;
449     esac
450     cmperr=$?
451     test $err = 0 && err=$cmperr
452     if [ "$report_type" = "ignore" ]; then
453         test $err = 0 || echo "IGNORE\t${test}" && err=0 && unset sig
454     else
455         test $err = 0 || cat $cmpfile
456     fi
457 else
458     echo "reference file '$ref' not found"
459     err=1
460 fi
461
462 if [ $err -eq 0 ] && test $report_type = "standard" ; then
463     unset cmpo erro
464 else
465     cmpo="$($base64 <$cmpfile)"
466     erro="$($base64 <$errfile)"
467 fi
468 echo "${test}:${sig:-$err}:$cmpo:$erro" >$repfile
469
470 if test $err != 0 && test $gen != "no" ; then
471     echo "GEN     $ref"
472     cp -f "$outfile" "$ref"
473     err=$?
474 fi
475
476 if test $err = 0; then
477     if test $keep = 0; then
478         rm -f $outfile $errfile $cmpfile $cleanfiles
479     fi
480 elif test $gen = "no"; then
481     echo "Test $test failed. Look at $errfile for details."
482     test "${V:-0}" -gt 0 && cat $errfile
483 else
484     echo "Updating reference failed, possibly no output file was generated."
485 fi
486 exit $err